package com.hmonitor.application;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;


import org.json.JSONObject;
import org.json.JSONTokener;

import com.hmonitor.application.R;

import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.text.Html;
import android.view.View;
import android.widget.*;


public class ConnectionActivity extends Activity {
	private EditText editTextPseudo;
	private EditText editTextPassword;
	private Button seConnecterButton;
	
	public void setEnabledAndFocusable(boolean bool) {
    	editTextPseudo.setEnabled(bool);
    	editTextPassword.setEnabled(bool);
    	seConnecterButton.setEnabled(bool);
	}
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	setResult(0);
        super.onCreate(savedInstanceState);
        setContentView(R.layout.connexion);
        
      	editTextPseudo = (EditText) findViewById(R.id.editTextPseudo);
    	editTextPassword = (EditText) findViewById(R.id.editTextPassword);
    	seConnecterButton = (Button) findViewById(R.id.seConnecterButton);

    }
    
    public void onClickSeConnecter(View v) { 

    	new ConnexionTask().execute();
    	
    	setEnabledAndFocusable(false);
    }
    
    
    
    private class ConnexionTask extends AsyncTask<String, Void, Boolean> {
    	
    	private String key;
    	private String name;
    	private String firstname;
    	private String phone;
    	private String age;
    	
        protected Boolean doInBackground(String... params) {
     	      	
        	String login = editTextPseudo.getText().toString(); 
        	String password = editTextPassword.getText().toString();
        	
        	String json = new String();
    		try {
    		    // Construct data
    		    String data = URLEncoder.encode("pseudo", "UTF-8") + "=" + URLEncoder.encode(login, "UTF-8");
    		    data += "&" + URLEncoder.encode("password", "UTF-8") + "=" + URLEncoder.encode(password, "UTF-8");

    		    // Send data
    		    URL url = new URL("http://176.31.250.25/user/loginApp/");
    		    URLConnection conn = url.openConnection();
    		    conn.setDoOutput(true);
    		    OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
    		    wr.write(data);
    		    wr.flush();

    		    // Get the response
    		    BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
    		    String line;
    		    while ((line = rd.readLine()) != null) {
    		        // Process line...
    		    	json = json + line;
    		    }
    		   
    		    wr.close();
    		    rd.close();
    		    
    		    if(json.contentEquals("")) {
    		    	return false;
    		    }
    		    
    		    else {
    			    json = Html.fromHtml(json).toString();
    			    
    		    	JSONObject object = (JSONObject) new JSONTokener(json).nextValue();
    		    	key = object.getString("key");
    		    	name = object.getString("name");
    		    	firstname = object.getString("firstname");
    		    	phone = object.getString("phone");
    		    	age = object.getString("age");
    			    
    			    return true;
    		    }
    		}
    		catch (Exception e) {
    			return false;
    			//Button button = (Button) findViewById(R.id.SeConnecter);
    		    //button.setText(e.getMessage());
    		}
        }

        protected void onPostExecute(Boolean result) {
        	TextView textView = (TextView) findViewById(R.id.textViewResult);
        	
            if(result == true) {
            	textView.setText("Connexion russie");
            	
            	Intent intent = new Intent();
            	Bundle data = new Bundle();
                data.putString("key", key); 
                data.putString("name", name);
                data.putString("firstname", firstname);
                data.putString("phone", phone);
                data.putString("age", age);
                
                intent.putExtras(data);
                
            	setResult(1, intent);
            	finish();
            }
            
            else {
            	textView.setText("Connexion impossible");
            }
         
            setEnabledAndFocusable(true);
        }

    }

}