package com.hmonitor.application;

import java.util.ArrayList;

import android.app.Service;
import android.content.Context;
import android.content.Intent;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.IBinder;
import android.widget.Toast;

public class GeolocalisationService extends Service implements LocationListener {
	
	private ArrayList<Localisation> localisations;
	
	private Location lastLocation;
	private Localisation lastLocalisation;
	
	private LocationManager lManager;
	
	
	@Override
	public void onLocationChanged(Location location) {
		this.lastLocation = location;
		addLocation();
		displayLocation();
	}

	@Override
	public void onProviderDisabled(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2) {
		// TODO Auto-generated method stub
		
	}
	
	private void displayLocation() {
		Toast.makeText(getBaseContext(), "Localisation : " + lastLocalisation, Toast.LENGTH_LONG).show();
	}
	
	private void addLocation(){
		lastLocalisation = new Localisation((lastLocation.getTime())/1000,String.valueOf(lastLocation.getLongitude()),String.valueOf(lastLocation.getLatitude()),String.valueOf(lastLocation.getAltitude()));
		localisations.add(lastLocalisation);
		((HMonitorApplication) getApplication()).setLastLocalisation(lastLocalisation);
		((HMonitorApplication) getApplication()).localisationValueTextView.setText(lastLocalisation.toString());
	}

	
	@Override
	public void onCreate(){
		localisations = ((HMonitorApplication) getApplication()).getLocalisations();
	}
	
	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {
		lManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
		lManager.requestLocationUpdates("network", 60000, 0, this);
		lManager.requestLocationUpdates("gps", 60000, 0, this);
	    // We want this service to continue running until it is explicitly
	    // stopped, so return sticky.
	    return START_STICKY;
	}

}
