package com.hmonitor.application;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.json.JSONException;
import org.json.JSONObject;

public class HeartRate implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7747065347924239769L;
	
	private long date;
	private String heartRate;
	
	public HeartRate(long date, String heartRate) {
		this.date = date;
		this.heartRate = heartRate;
	}
	
	public HeartRate(JSONObject obj) throws JSONException {
		deserializeFromObj(obj);
	}
	
	public void deserializeFromObj(JSONObject obj) throws JSONException {
		this.setDate(Long.parseLong(obj.getString("date"))*1000);
		this.setHeartRate(obj.getString("heartRate"));
	}
	
	public String serializeToJson() {
		JSONObject obj=new JSONObject();
		try {
			obj.put("heartRate",heartRate);
			obj.put("date",String.valueOf(date));
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		  return obj.toString();
	}
	
	public String getHeartRate() {
		return heartRate;
	}

	public void setHeartRate(String heartRate) {
		this.heartRate = heartRate;
	}
	
	public long getDate() {
		return date;
	}

	public void setDate(long date) {
		this.date = date;
	}
		
	public String toString() {
		return 	getFormatedDate() + " " + heartRate;
	}
	
	public String getFormatedDate() {
		Date updateDate = new Date(getDate()*1000);
		SimpleDateFormat formatDateJour = new SimpleDateFormat("dd/MM/yyyy kk:mm:ss");
		String formatedDate = formatDateJour.format(updateDate); 
		
		return formatedDate;
	}
}
