package com.hmonitor.application;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.json.JSONException;
import org.json.JSONObject;

public class Localisation implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 4408446581771860463L;

	private long date;
	private String longitude;
	private String latitude;
	private String altitude;
	
	public Localisation(long date, String longitude, String latitude, String altitude) {
		this.date = date;
		this.longitude = longitude;
		this.latitude = latitude;
		this.altitude = altitude;
	}
	
	public Localisation(JSONObject obj) throws JSONException {
		deserializeFromObj(obj);
	}
	
	public void deserializeFromObj(JSONObject obj) throws JSONException {
		this.setDate(Long.parseLong(obj.getString("date"))*1000);
		this.setLongitude(obj.getString("longitude"));
		this.setLatitude(obj.getString("latitude"));
		this.setAltitude(obj.getString("altitude"));
	}
	
	public String serializeToJson() {
		JSONObject obj=new JSONObject();
		try {
			obj.put("longitude",longitude);
			obj.put("latitude",latitude);
			obj.put("altitude",altitude);
			obj.put("date",String.valueOf(date));
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		  return obj.toString();
	}

	public long getDate() {
		return date;
	}

	public void setDate(long date) {
		this.date = date;
	}

	public String getLongitude() {
		return longitude;
	}

	public void setLongitude(String longitude) {
		this.longitude = longitude;
	}

	public String getLatitude() {
		return latitude;
	}

	public void setLatitude(String latitude) {
		this.latitude = latitude;
	}

	public String getAltitude() {
		return altitude;
	}

	public void setAltitude(String altitude) {
		this.altitude = altitude;
	}
	
	public String toString() {
		return 	getFormatedDate() + " " + longitude + " " + latitude + " " + altitude;
	}
	
	public String getFormatedDate() {
		Date updateDate = new Date(getDate()*1000);
		SimpleDateFormat formatDateJour = new SimpleDateFormat("dd/MM/yyyy kk:mm:ss");
		String formatedDate = formatDateJour.format(updateDate); 
		
		return formatedDate;
	}
}
