package com.hmonitor.application;
 
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.Date;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.text.Html;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class PrincipalActivity extends Activity {
	private ArrayList<Localisation> localisations;
	       
    private String key;
	private String name;
	private String firstname;
	
	
	private boolean isConnected;
 	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        localisations = ((HMonitorApplication) getApplication()).getLocalisations();
        //isConnected = false;
         
        setContentView(R.layout.principal);
        
        TextView localisationValueTextView;
        localisationValueTextView = (TextView) findViewById(R.id.localisationValue);
        ((HMonitorApplication) getApplication()).localisationValueTextView  = localisationValueTextView;
 

       if(isConnected){
    	   ((TextView)findViewById(R.id.welcomeValue)).setText("Connected");
       }
        
    	Intent geolocalisationService = new Intent(PrincipalActivity.this, GeolocalisationService.class);
        startService(geolocalisationService);
        
    	Intent heartRateService = new Intent(PrincipalActivity.this, HeartRateService.class);
        startService(heartRateService);
        
        if(isConnected) {
        	Intent sendDataService = new Intent(PrincipalActivity.this, SendDataService.class);
            startService(sendDataService);
        }

    }
 
	
	private boolean obtainLastPositions() {
	    if(isConnected == true) {
			String json = new String();
			try {
			    // Construct data
			    String data = URLEncoder.encode("key", "UTF-8") + "=" + URLEncoder.encode(key, "UTF-8");
		
			    // Send data
			    URL url = new URL("http://ks387630.kimsufi.com/user/locate/");
			    URLConnection conn = url.openConnection();
			    conn.setDoOutput(true);
			    OutputStreamWriter wr = new OutputStreamWriter(conn.getOutputStream());
			    wr.write(data);
			    wr.flush();
		
			    // Get the response
			    BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			    String line;
			    while ((line = rd.readLine()) != null) {
			        // Process line...
			    	json = json + line;
			    }
			   
			    wr.close();
			    rd.close();
			    
			    if(json.contentEquals("")) {
			    	return false;
			    }
			    
			    else {
				    json = Html.fromHtml(json).toString();
				    
				    ArrayList<Localisation> localisations = deserializeArray(json);
			    	
		    		TextView welcomeValue = (TextView)findViewById(R.id.welcomeValue);
		    		welcomeValue.setText(localisations.get(0).toString());
				    
			    }
			}
			catch (Exception e) {

			}
		    
	    }
	    
	    return true;
	}
  
	
	public static ArrayList<Localisation> deserializeArray(String serializedArray) throws JSONException {
			JSONArray jsonObjs = new JSONArray(serializedArray);
			ArrayList<Localisation> localisations = new ArrayList<Localisation>();
			
			for (int i=0; i<jsonObjs.length(); i++) {
				JSONObject localisation = jsonObjs.getJSONObject(i);
				localisations.add(new Localisation(localisation));
			}
	
			return localisations;
	 }

    public void onClickSeConnecter(View v) { 
    	
    	Bundle objetbundle = new Bundle();

    	objetbundle.putBoolean("isConnected", false);
		objetbundle.putString("key", "");
		objetbundle.putString("name", "");
		objetbundle.putString("firstname", "");
		
        Intent connectionIntent = new Intent(PrincipalActivity.this, ConnectionActivity.class);
        connectionIntent.putExtras(objetbundle);
        
        startActivityForResult(connectionIntent, 0);
    }
    
    protected void onActivityResult(int requestCode, int resultCode, Intent data){
    	// request = 0 : Connection
    	
    	if(resultCode == 1) {
    		isConnected = true;
    		
        	Bundle objetbundle = data.getExtras();
    		key = objetbundle.getString("key");
    		((HMonitorApplication) getApplication()).setKey(key);
    		name= objetbundle.getString("name");
    		firstname = objetbundle.getString("firstname");
    		
    		((HMonitorApplication) getApplication()).setPhone(objetbundle.getString("phone"));
    		((HMonitorApplication) getApplication()).setAge(objetbundle.getString("age"));
    		((HMonitorApplication) getApplication()).setFirstName(firstname);
    		((HMonitorApplication) getApplication()).setName(name);
    		TextView welcomeValue = (TextView)findViewById(R.id.welcomeValue);
    		welcomeValue.setText("Welcome " + firstname + " " + name);
    		
    		Button seConnecterButton = (Button) findViewById(R.id.seConnecterButton);
    		seConnecterButton.setVisibility(View.GONE);
    		  		
    		Intent sendDataService = new Intent(PrincipalActivity.this, SendDataService.class);
            startService(sendDataService);
    	
    	}
    }

}