package com.hmonitor.application;

import java.util.ArrayList;

import android.app.Notification;
import android.app.PendingIntent;
import android.app.Service;
import android.content.Intent;
import android.os.IBinder;

public class SendDataService extends Service{
    private ArrayList<Localisation> localisations;
    private ArrayList<HeartRate> heartrates;
    private String key;

	@Override
	public void onCreate(){
		localisations = ((HMonitorApplication) getApplication()).getLocalisations();
		heartrates = ((HMonitorApplication) getApplication()).getHeartRates();
		key = ((HMonitorApplication) getApplication()).getKey();
	}

	@Override
	public IBinder onBind(Intent arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
	@Override
	public int onStartCommand(Intent intent, int flags, int startId) {

		Notification note=new Notification(R.drawable.ic_stat_hmonitor,
                                      "H-Monitor is connected to the server",
                                     System.currentTimeMillis());

		PendingIntent pendingIntent = PendingIntent.getActivity(this, 0, new Intent(this, PrincipalActivity.class), 0);
  
		note.setLatestEventInfo(this, "H-Monitor",
          "H-Monitor is sending periodically data to the server", pendingIntent);

		startForeground(12, note);
	      
		new Thread(new SendDataThread(localisations, heartrates, key)).start();

	    // We want this service to continue running until it is explicitly
	    // stopped, so return sticky.
	    return START_STICKY;
	}

}
