package com.hmonitor.application;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;

public class SendDataThread implements Runnable{
	ArrayList<Localisation> localisations;
	ArrayList<HeartRate> heartRates;
	String key;
	DefaultHttpClient client;
	
	SendDataThread(ArrayList<Localisation> localisations, ArrayList<HeartRate> heartRates, String key) {
		client = new DefaultHttpClient();
		this.localisations = localisations;
		this.heartRates = heartRates;
		this.key = key;
	}
	
	public void run() {
		
		while(true) {
			try {
				sendLocalisations();
				sendHeartRates();
				Thread.sleep(60000);
			}
			catch(Exception e) {
					e.printStackTrace();
			}
		}
		
	}
	
	public void sendLocalisations() throws Exception {
		ArrayList<Localisation> toBeRemoved = new ArrayList<Localisation>();
		
        List <NameValuePair> nvps = new ArrayList <NameValuePair>();
        String htmlResponse;
        System.out.println("run");           
        nvps.add(new BasicNameValuePair("key", key));
        
        Localisation []localisationsArray = new Localisation[localisations.size()];
        localisations.toArray(localisationsArray);
        for(Localisation localisation : localisationsArray) {
        	System.out.println(localisation);
        	BasicNameValuePair basicNameValuePair = new BasicNameValuePair("localisation", localisation.serializeToJson());
        	nvps.add(basicNameValuePair);
        	htmlResponse = sendPostRequest("http://176.31.250.25/user/addLocation/", nvps);
        	if(htmlResponse.equals("1\n")) toBeRemoved.add(localisation);
        	nvps.remove(basicNameValuePair);
        }
        
	    for(Localisation localisation : toBeRemoved) {
	    	localisations.remove(localisation);
	    }
	}
	
	public void sendHeartRates() throws Exception {
        List <NameValuePair> nvps = new ArrayList <NameValuePair>();
        String htmlResponse;
        System.out.println("run");           
        nvps.add(new BasicNameValuePair("key", key));
        
        HeartRate []heartRatesArray = new HeartRate[heartRates.size()];
        heartRates.toArray(heartRatesArray);
        for(HeartRate heartRate : heartRatesArray) {
        	System.out.println(heartRate);
        	BasicNameValuePair basicNameValuePair = new BasicNameValuePair("heartRate", heartRate.serializeToJson());
        	nvps.add(basicNameValuePair);
        	htmlResponse = sendPostRequest("http://ks387630.kimsufi.com/user/addHeartRate/", nvps);
        	if(htmlResponse.equals("1\n")) {
        		heartRates.remove(heartRate);
        	}
        	nvps.remove(basicNameValuePair);
        }
	}
	
	public String sendPostRequest(String url, List<NameValuePair> nvps) {
		HttpPost post = new HttpPost(url);
		
		String htmlResponse ="";
        try {
			post.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));
			HttpResponse response = client.execute(post);
			htmlResponse = getHtmlResponse(response);

		} catch (Exception e) {
			e.printStackTrace();
		}
        
		return htmlResponse;
	}
	
	public String getHtmlResponse(HttpResponse response) {
		String htmlResponse = "";
		
		try {
			BufferedReader rd;
			rd = new BufferedReader(new InputStreamReader(
					response.getEntity().getContent()));

			String line = "";
			
			while ((line = rd.readLine()) != null) {
				htmlResponse = htmlResponse + line + "\n";
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return htmlResponse;
	}
}
